#include "hw_profile.h"
#include "baudrate.h"

uint16_t calc_bgr(uint32_t baudrate, uint16_t brgh)
{
  unsigned long Fcy = FCY; 
  unsigned int bgr = 0, realbr, br_error, brg_div, ierr_percent;
  float ferr_percent;
  brg_div = brgh ? 4 : 16;  
  bgr = ((Fcy + (brg_div/2*baudrate))/brg_div/baudrate-1);
  realbr = (Fcy/brg_div/(bgr+1));
  br_error = ((realbr > baudrate) ? realbr-baudrate : baudrate-realbr);
  ferr_percent = (((float)br_error*100.)/(float)baudrate);  
  ierr_percent = ((br_error*100+baudrate/2)/baudrate);  
  return bgr;
}
