#include "hw_profile.h"
#include "baudrate.h"
#include "uart2_p.h"

unsigned char uart2_put_get(unsigned char ch)
{
    unsigned char ret;
    /* wait for empty buffer */
    while (U2STAbits.UTXBF == 1);
    U2TXREG = ch;

    while (U2STAbits.TRMT == 0);
    if (U2STAbits.URXDA)
        ret = U2RXREG;
    else
        ret = 0x0;

    return ret;
}

unsigned char uart2_put_get_old(unsigned char ch)
{
    unsigned char ret;
    /* wait for empty buffer */
    while (U2STAbits.UTXBF == 1);
    U2TXREG = ch;

    while (U2STAbits.URXDA == 0);
    ret = U2RXREG;

    return ret;
}

void uart2_init_115200(void)
{
    _U2TXIE = 0;
    _U2RXIE = 0;
    U2STA = 0;
    U2MODE = 0;
    U2BRG = BAUDRATEREG115200; //calc_bgr(115200, 1);
    U2MODEbits.BRGH = 1;
    U2MODEbits.UARTEN = 1;
    U2STAbits.UTXEN = 1;

}

void uart2_init_9600(void)
{
    _U2TXIE = 0;
    _U2RXIE = 0;
    U2STA = 0;
    U2MODE = 0;
    /* Initialize UART1 */
    U2BRG = BAUDRATEREG9600; //calc_bgr(9600, 0);
    U2MODEbits.BRGH = 0;
    U2MODEbits.UARTEN = 1;
    U2STAbits.UTXEN = 1;

}
