#ifndef BAUDRATE_H
#define BAUDRATE_H


#include "hw_profile.h"

#define BRGH_CONST      1

/****************************************************************************
  Section: UART baud rate calculation
 ***************************************************************************/
#if (BRGH_CONST == 1)
#define BRG_DIV 4
#else
#define BRG_DIV 16
#endif

#define BAUDRATEREG9600    ((FCY + (BRG_DIV/2*9600)) / 16 / 9600-1)
//#define BAUD_ACTUAL    (FCY/BRG_DIV/(BAUDRATEREG+1))

#define BAUDRATEREG115200    ((FCY + (BRG_DIV/2*115200)) / 4 / 115200-1)
//#define BAUD_ACTUAL    (FCY/BRG_DIV/(BAUDRATEREG+1))

#define BAUDRATEREG    ((FCY + (BRG_DIV/2*BAUDRATE))/BRG_DIV/BAUDRATE-1)
#define BAUD_ACTUAL    (FCY/BRG_DIV/(BAUDRATEREG+1))

#define BAUD_ERROR          ((BAUD_ACTUAL > BAUDRATE) ? BAUD_ACTUAL-BAUDRATE : BAUDRATE-BAUD_ACTUAL)
#define BAUD_ERROR_PRECENT  ((BAUD_ERROR*100+BAUDRATE/2)/BAUDRATE)

#if (BAUD_ERROR_PRECENT > 3)
#error "UART frequency error is worse than 3%"
#elif (BAUD_ERROR_PRECENT > 1)
#warning "UART frequency error is worse than 1%"
#endif

extern uint16_t calc_bgr(uint32_t baudrate, uint16_t brgh);

#endif
