/* 
 * File:   ds18b20.h
 * Author: Dmitriy
 *
 */

#ifndef DS18B20_H
#define	DS18B20_H

#ifdef	__cplusplus
extern "C" {
#endif

    enum {
        ALARM_SEARCH = 0xEC,
        CONVERT_T = 0x44,
        WRITE_SCRATCHPAD = 0x4E,
        READ_SCRATCHPAD = 0xBE,
        COPY_SCRATCHPAD = 0x48,
        RECALL_EE = 0xB8,
        READ_POWER_SUPPLY = 0xB4
    };

    typedef enum {
        DS18B20_OK = 0,
        DS18B20_NOTFOUND,
        DS18B20_NOTTERM,
        DS18B20_CRCERR,
        DS18B20_NOTVALID,
        DS18B20_TOOMANYDEVS,
    } DS18B20_RESULT;

    enum {
        OW_FAMILY_TERMO = 0x28,
        MAX_TERMOS = 32,
    };

    DS18B20_RESULT start_convert_single(void);
    DS18B20_RESULT start_convert(uint8_t dev);
    DS18B20_RESULT read_temperature_single(float *temp_c);
    DS18B20_RESULT read_temperature(uint8_t dev, float *temp_c);
    DS18B20_RESULT setTermoROM(uint8_t *ROM);
    inline uint8_t getTermoCount(void);

#ifdef	__cplusplus
}
#endif

#endif	/* DS18B20_H */

