/* 
 * File:   ds1904.h
 * Author: Dmitriy
 *
 * Created on 1  2013 ., 14:23
 */

#ifndef DS1904_H
#define	DS1904_H

#ifdef	__cplusplus
extern "C" {
#endif

    enum {
        READ_CLOCK = 0x66,
        WRITE_CLOCK = 0x99
    };

    typedef enum {
        OWRTC_OK = 0,
        OWRTC_NOTFOUND,
        OWRTC_NOTCLOCK,
        OWRTC_CRCERR,
        OWRTC_NOTVALID,
        OWRTC_CTRLBYTE
    } OWRTC_RESULT;

    enum {
        OW_FAMILY_CLOCK = 0x24
    };

    typedef struct {
        uint8_t control_byte;
        uint8_t ROM[8];
        uint8_t valid;

        union {
            time_t unixtime;
            uint8_t time_bytes[sizeof (time_t)];
        };
    } OWRTC;

    OWRTC_RESULT initOWRTC(uint8_t *);
    OWRTC_RESULT read_clock(time_t *);
    OWRTC_RESULT write_clock(time_t );

    OWRTC_RESULT read_clock_single(time_t *);
    OWRTC_RESULT write_clock_single(time_t );

    OWRTC_RESULT write_flags(uint8_t );
    OWRTC_RESULT read_flags(uint8_t* );


    OWRTC_RESULT set_control_byte(uint8_t );
#ifdef	__cplusplus
}
#endif

#endif	/* DS1904_H */

