/* 
 * File:   ow_rom.h
 * Author: Dmitriy
 *
 * Created on 1  2013 ., 14:21
 */

#ifndef OW_ROM_H
#define	OW_ROM_H

#ifdef	__cplusplus
extern "C" {
#endif


enum {
    READ_ROM = 0x33,
    SKIP_ROM = 0xCC,
    MATCH_ROM = 0x55,
    SEARCH_ROM = 0xF0,
    READ_ROM_KEY = 0x0F
};

extern unsigned char ROM_NO[8];

// method declarations
int  OWFirst();
int  OWNext();
int  OWVerify();
void OWTargetSetup(unsigned char family_code);
void OWFamilySkipSetup();
int  OWReset();
void OWWriteByte(unsigned char byte_value);
void OWWriteBit(unsigned char bit_value);
unsigned char OWReadBit();
unsigned char OWReadByte();
int  OWSearch();
void OWMatch();
unsigned char docrc8(unsigned char value);


#ifdef	__cplusplus
}
#endif

#endif	/* OW_ROM_H */

